diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-dctcp.cc ns-3.31/src/internet/model/tcp-dctcp.cc
--- ns-3.30.1/src/internet/model/tcp-dctcp.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-dctcp.cc	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,272 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Shravya K.S. <shravya.ks0@gmail.com>
+ *
+ */
+
+#include "tcp-dctcp.h"
+#include "ns3/log.h"
+#include "math.h"
+#include "ns3/tcp-socket-state.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("TcpDctcp");
+
+NS_OBJECT_ENSURE_REGISTERED (TcpDctcp);
+
+TypeId TcpDctcp::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::TcpDctcp")
+    .SetParent<TcpNewReno> ()
+    .AddConstructor<TcpDctcp> ()
+    .SetGroupName ("Internet")
+    .AddAttribute ("DctcpShiftG",
+                   "Parameter G for updating dctcp_alpha",
+                   DoubleValue (0.0625),
+                   MakeDoubleAccessor (&TcpDctcp::m_g),
+                   MakeDoubleChecker<double> (0, 1))
+    .AddAttribute ("DctcpAlphaOnInit",
+                   "Initial alpha value",
+                   DoubleValue (1.0),
+                   MakeDoubleAccessor (&TcpDctcp::SetDctcpAlpha),
+                   MakeDoubleChecker<double> (0, 1))
+    .AddAttribute ("UseEct0",
+                   "Use ECT(0) for ECN codepoint, if false use ECT(1)",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&TcpDctcp::m_useEct0),
+                   MakeBooleanChecker ())
+  ;
+  return tid;
+}
+
+std::string TcpDctcp::GetName () const
+{
+  return "TcpDctcp";
+}
+
+TcpDctcp::TcpDctcp ()
+  : TcpNewReno ()
+{
+  NS_LOG_FUNCTION (this);
+  m_ackedBytesEcn = 0;
+  m_ackedBytesTotal = 0;
+  m_priorRcvNxt = SequenceNumber32 (0);
+  m_priorRcvNxtFlag = false;
+  m_nextSeq = SequenceNumber32 (0);
+  m_nextSeqFlag = false;
+  m_ceState = false;
+  m_delayedAckReserved = false;
+}
+
+TcpDctcp::TcpDctcp (const TcpDctcp& sock)
+  : TcpNewReno (sock),
+    m_ackedBytesEcn (sock.m_ackedBytesEcn),
+    m_ackedBytesTotal (sock.m_ackedBytesTotal),
+    m_priorRcvNxt (sock.m_priorRcvNxt),
+    m_priorRcvNxtFlag (sock.m_priorRcvNxtFlag),
+    m_alpha (sock.m_alpha),
+    m_nextSeq (sock.m_nextSeq),
+    m_nextSeqFlag (sock.m_nextSeqFlag),
+    m_ceState (sock.m_ceState),
+    m_delayedAckReserved (sock.m_delayedAckReserved),
+    m_g (sock.m_g),
+    m_useEct0 (sock.m_useEct0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TcpDctcp::~TcpDctcp (void)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+Ptr<TcpCongestionOps> TcpDctcp::Fork (void)
+{
+  NS_LOG_FUNCTION (this);
+  return CopyObject<TcpDctcp> (this);
+}
+
+void
+TcpDctcp::Init (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  NS_LOG_INFO (this << "Enabling DctcpEcn for DCTCP");
+  tcb->m_useEcn = TcpSocketState::On;
+  tcb->m_ecnMode = TcpSocketState::DctcpEcn;
+  tcb->m_ectCodePoint = m_useEct0 ? TcpSocketState::Ect0 : TcpSocketState::Ect1;
+}
+
+void
+TcpDctcp::ReduceCwnd (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  uint32_t val = static_cast<uint32_t> ((1 - m_alpha / 2.0) * tcb->m_cWnd);
+  tcb->m_cWnd = std::max (val, 2 * tcb->m_segmentSize);
+}
+
+void
+TcpDctcp::PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked, const Time &rtt)
+{
+  NS_LOG_FUNCTION (this << tcb << segmentsAcked << rtt);
+  m_ackedBytesTotal += segmentsAcked * tcb->m_segmentSize;
+  if (tcb->m_ecnState == TcpSocketState::ECN_ECE_RCVD)
+    {
+      m_ackedBytesEcn += segmentsAcked * tcb->m_segmentSize;
+    }
+  if (m_nextSeqFlag == false)
+    {
+      m_nextSeq = tcb->m_nextTxSequence;
+      m_nextSeqFlag = true;
+    }
+  if (tcb->m_lastAckedSeq >= m_nextSeq)
+    {
+      double bytesEcn = 0.0;
+      if (m_ackedBytesTotal >  0)
+        {
+          bytesEcn = static_cast<double> (m_ackedBytesEcn * 1.0 / m_ackedBytesTotal);
+        }
+      m_alpha = (1.0 - m_g) * m_alpha + m_g * bytesEcn;
+      NS_LOG_INFO (this << "bytesEcn " << bytesEcn << ", m_alpha " << m_alpha);
+      Reset (tcb);
+    }
+}
+
+void
+TcpDctcp::SetDctcpAlpha (double alpha)
+{
+  NS_LOG_FUNCTION (this << alpha);
+  m_alpha = alpha;
+}
+
+void
+TcpDctcp::Reset (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  m_nextSeq = tcb->m_nextTxSequence;
+  m_ackedBytesEcn = 0;
+  m_ackedBytesTotal = 0;
+}
+
+void
+TcpDctcp::CeState0to1 (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  if (!m_ceState && m_delayedAckReserved && m_priorRcvNxtFlag)
+    {
+      SequenceNumber32 tmpRcvNxt;
+      /* Save current NextRxSequence. */
+      tmpRcvNxt = tcb->m_rxBuffer->NextRxSequence ();
+
+      /* Generate previous ACK without ECE */
+      tcb->m_rxBuffer->SetNextRxSequence (m_priorRcvNxt);
+      tcb->m_sendEmptyPacketCallback (TcpHeader::ACK);
+
+      /* Recover current RcvNxt. */
+      tcb->m_rxBuffer->SetNextRxSequence (tmpRcvNxt);
+    }
+
+  if (m_priorRcvNxtFlag == false)
+    {
+      m_priorRcvNxtFlag = true;
+    }
+  m_priorRcvNxt = tcb->m_rxBuffer->NextRxSequence ();
+  m_ceState = true;
+  tcb->m_ecnState = TcpSocketState::ECN_CE_RCVD;
+}
+
+void
+TcpDctcp::CeState1to0 (Ptr<TcpSocketState> tcb)
+{
+  NS_LOG_FUNCTION (this << tcb);
+  if (m_ceState && m_delayedAckReserved && m_priorRcvNxtFlag)
+    {
+      SequenceNumber32 tmpRcvNxt;
+      /* Save current NextRxSequence. */
+      tmpRcvNxt = tcb->m_rxBuffer->NextRxSequence ();
+
+      /* Generate previous ACK with ECE */
+      tcb->m_rxBuffer->SetNextRxSequence (m_priorRcvNxt);
+      tcb->m_sendEmptyPacketCallback (TcpHeader::ACK | TcpHeader::ECE);
+
+      /* Recover current RcvNxt. */
+      tcb->m_rxBuffer->SetNextRxSequence (tmpRcvNxt);
+    }
+
+  if (m_priorRcvNxtFlag == false)
+    {
+      m_priorRcvNxtFlag = true;
+    }
+  m_priorRcvNxt = tcb->m_rxBuffer->NextRxSequence ();
+  m_ceState = false;
+
+  if (tcb->m_ecnState == TcpSocketState::ECN_CE_RCVD || tcb->m_ecnState == TcpSocketState::ECN_SENDING_ECE)
+    {
+      tcb->m_ecnState = TcpSocketState::ECN_IDLE;
+    }
+}
+
+void
+TcpDctcp::UpdateAckReserved (Ptr<TcpSocketState> tcb,
+                             const TcpSocketState::TcpCAEvent_t event)
+{
+  NS_LOG_FUNCTION (this << tcb << event);
+  switch (event)
+    {
+    case TcpSocketState::CA_EVENT_DELAYED_ACK:
+      if (!m_delayedAckReserved)
+        {
+          m_delayedAckReserved = true;
+        }
+      break;
+    case TcpSocketState::CA_EVENT_NON_DELAYED_ACK:
+      if (m_delayedAckReserved)
+        {
+          m_delayedAckReserved = false;
+        }
+      break;
+    default:
+      /* Don't care for the rest. */
+      break;
+    }
+}
+
+void
+TcpDctcp::CwndEvent (Ptr<TcpSocketState> tcb,
+                     const TcpSocketState::TcpCAEvent_t event)
+{
+  NS_LOG_FUNCTION (this << tcb << event);
+  switch (event)
+    {
+    case TcpSocketState::CA_EVENT_ECN_IS_CE:
+      CeState0to1 (tcb);
+      break;
+    case TcpSocketState::CA_EVENT_ECN_NO_CE:
+      CeState1to0 (tcb);
+      break;
+    case TcpSocketState::CA_EVENT_DELAYED_ACK:
+    case TcpSocketState::CA_EVENT_NON_DELAYED_ACK:
+      UpdateAckReserved (tcb, event);
+      break;
+    default:
+      /* Don't care for the rest. */
+      break;
+    }
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-dctcp.h ns-3.31/src/internet/model/tcp-dctcp.h
--- ns-3.30.1/src/internet/model/tcp-dctcp.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.31/src/internet/model/tcp-dctcp.h	2020-06-27 17:38:30.000000000 -0700
@@ -0,0 +1,158 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 NITK Surathkal
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Shravya K.S. <shravya.ks0@gmail.com>
+ *
+ */
+
+#ifndef TCP_DCTCP_H
+#define TCP_DCTCP_H
+
+#include "ns3/tcp-congestion-ops.h"
+
+namespace ns3 {
+
+/**
+ * \ingroup tcp
+ *
+ * \brief An implementation of DCTCP. This model implements all the functionalities mentioned
+ * in the DCTCP SIGCOMM paper except dynamic buffer allocation in switches
+ */
+
+class TcpDctcp : public TcpNewReno
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * Create an unbound tcp socket.
+   */
+  TcpDctcp ();
+
+  /**
+   * \brief Copy constructor
+   * \param sock the object to copy
+   */
+  TcpDctcp (const TcpDctcp& sock);
+
+  /**
+   * \brief Destructor
+   */
+  virtual ~TcpDctcp (void);
+
+  /**
+   * \brief Get the name of the TCP flavour
+   *
+   * \return The name of the TCP
+   */
+  virtual std::string GetName () const;
+
+  /**
+   * \brief Set configuration required by congestion control algorithm,
+   *        This method will force DctcpEcn mode and will force usage of
+   *        either ECT(0) or ECT(1) (depending on the 'UseEct0' attribute),
+   *        despite any other configuration in the base classes.
+   *
+   * \param ecnMode ECN Mode
+   */
+  virtual void Init (Ptr<TcpSocketState> tcb);
+
+  virtual Ptr<TcpCongestionOps> Fork ();
+
+  /**
+   * \brief Reduce congestion window based on DCTCP algorithm
+   *
+   * \param tcb internal congestion state
+   */
+  virtual void ReduceCwnd (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Get information from the acked packet
+   *
+   * \param tcb internal congestion state
+   * \param segmentsAcked count of segments ACKed
+   * \param rtt The estimated rtt
+   */
+  virtual void PktsAcked (Ptr<TcpSocketState> tcb, uint32_t segmentsAcked,
+                          const Time &rtt);
+  /**
+   * \brief Trigger events/calculations on occurrence of congestion window event
+   *
+   * \param tcb internal state
+   * \param event congestion window event which triggered this function
+   */
+  virtual void CwndEvent (Ptr<TcpSocketState> tcb,
+                          const TcpSocketState::TcpCAEvent_t event);
+private:
+  /**
+   * \brief Changes state of m_ceState to true
+   *
+   * \param tcb internal congestion state
+   */
+  void CeState0to1 (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Changes state of m_ceState to false
+   *
+   * \param tcb internal congestion state
+   */
+  void CeState1to0 (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Updates the value of m_delayedAckReserved
+   *
+   * \param tcb internal congestion state
+   * \param event the congestion window event
+   */
+  void UpdateAckReserved (Ptr<TcpSocketState> tcb,
+                          const TcpSocketState::TcpCAEvent_t event);
+
+  /**
+   * \brief Resets the value of m_ackedBytesEcn, m_ackedBytesTotal and m_nextSeq
+   *
+   * \param tcb internal congestion state
+   */
+  void Reset (Ptr<TcpSocketState> tcb);
+
+  /**
+   * \brief Sets the value of m_alpha
+   *
+   * \param alpha DCTCP alpha parameter
+   */
+  void SetDctcpAlpha (double alpha);
+
+  uint32_t m_ackedBytesEcn;             //!< Number of acked bytes which are marked
+  uint32_t m_ackedBytesTotal;           //!< Total number of acked bytes
+  SequenceNumber32 m_priorRcvNxt;       //!< Sequence number of the first missing byte in data
+  bool m_priorRcvNxtFlag;               //!< Variable used in setting the value of m_priorRcvNxt for first time
+  double m_alpha;                       //!< Parameter used to estimate the amount of network congestion
+  SequenceNumber32 m_nextSeq;           //!< TCP sequence number threshold for beginning a new observation window
+  bool m_nextSeqFlag;                   //!< Variable used in setting the value of m_nextSeq for first time
+  bool m_ceState;                       //!< DCTCP Congestion Experienced state
+  bool m_delayedAckReserved;            //!< Delayed Ack state
+  double m_g;                           //!< Estimation gain
+  bool m_useEct0;                       //!< Use ECT(0) for ECN codepoint
+};
+
+} // namespace ns3
+
+#endif /* TCP_DCTCP_H */
+
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-highspeed.cc ns-3.31/src/internet/model/tcp-highspeed.cc
--- ns-3.30.1/src/internet/model/tcp-highspeed.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-highspeed.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,6 +18,8 @@
  */
 
 #include "tcp-highspeed.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-highspeed.h ns-3.31/src/internet/model/tcp-highspeed.h
--- ns-3.30.1/src/internet/model/tcp-highspeed.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-highspeed.h	2020-06-27 17:38:30.000000000 -0700
@@ -20,11 +20,12 @@
 #ifndef TCPHIGHSPEED_H
 #define TCPHIGHSPEED_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-htcp.h ns-3.31/src/internet/model/tcp-htcp.h
--- ns-3.30.1/src/internet/model/tcp-htcp.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-htcp.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,11 +27,12 @@
 #ifndef TCP_HTCP_H
 #define TCP_HTCP_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-hybla.cc ns-3.31/src/internet/model/tcp-hybla.cc
--- ns-3.30.1/src/internet/model/tcp-hybla.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-hybla.cc	2020-06-27 17:38:30.000000000 -0700
@@ -18,8 +18,9 @@
  */
 
 #include "tcp-hybla.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
-#include "ns3/tcp-socket-base.h"
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-hybla.h ns-3.31/src/internet/model/tcp-hybla.h
--- ns-3.30.1/src/internet/model/tcp-hybla.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-hybla.h	2020-06-27 17:38:30.000000000 -0700
@@ -19,12 +19,13 @@
 #ifndef TCPHYBLA_H
 #define TCPHYBLA_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 #include "ns3/traced-value.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-illinois.cc ns-3.31/src/internet/model/tcp-illinois.cc
--- ns-3.30.1/src/internet/model/tcp-illinois.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-illinois.cc	2020-06-27 17:38:30.000000000 -0700
@@ -27,6 +27,8 @@
 
 
 #include "tcp-illinois.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-illinois.h ns-3.31/src/internet/model/tcp-illinois.h
--- ns-3.30.1/src/internet/model/tcp-illinois.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-illinois.h	2020-06-27 17:38:30.000000000 -0700
@@ -28,11 +28,12 @@
 #ifndef TCPILLINOIS_H
 #define TCPILLINOIS_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-l4-protocol.cc ns-3.31/src/internet/model/tcp-l4-protocol.cc
--- ns-3.30.1/src/internet/model/tcp-l4-protocol.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-l4-protocol.cc	2020-06-27 17:38:30.000000000 -0700
@@ -97,8 +97,7 @@
 TcpL4Protocol::TcpL4Protocol ()
   : m_endPoints (new Ipv4EndPointDemux ()), m_endPoints6 (new Ipv6EndPointDemux ())
 {
-  NS_LOG_FUNCTION_NOARGS ();
-  NS_LOG_LOGIC ("Made a TcpL4Protocol " << this);
+  NS_LOG_FUNCTION (this);
 }
 
 TcpL4Protocol::~TcpL4Protocol ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-ledbat.cc ns-3.31/src/internet/model/tcp-ledbat.cc
--- ns-3.30.1/src/internet/model/tcp-ledbat.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-ledbat.cc	2020-06-27 17:38:30.000000000 -0700
@@ -20,8 +20,10 @@
  */
 
 #include "tcp-ledbat.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
-#include "ns3/simulator.h"
+#include "ns3/simulator.h" // Now ()
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-ledbat.h ns-3.31/src/internet/model/tcp-ledbat.h
--- ns-3.30.1/src/internet/model/tcp-ledbat.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-ledbat.h	2020-06-27 17:38:30.000000000 -0700
@@ -22,12 +22,14 @@
 #ifndef TCP_LEDBAT_H
 #define TCP_LEDBAT_H
 
+#include "tcp-congestion-ops.h"
+
 #include <vector>
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 /**
  * \ingroup congestionOps
  *
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-lp.cc ns-3.31/src/internet/model/tcp-lp.cc
--- ns-3.30.1/src/internet/model/tcp-lp.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-lp.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,8 +22,9 @@
  */
 
 #include "tcp-lp.h"
-#include "ns3/tcp-socket-base.h"
+
 #include "ns3/log.h"
+#include "ns3/simulator.h"
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-lp.h ns-3.31/src/internet/model/tcp-lp.h
--- ns-3.30.1/src/internet/model/tcp-lp.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-lp.h	2020-06-27 17:38:30.000000000 -0700
@@ -24,12 +24,14 @@
 #ifndef TCPLP_H
 #define TCPLP_H
 
-#include "ns3/tcp-congestion-ops.h"
-#include "ns3/tcp-recovery-ops.h"
+#include "tcp-congestion-ops.h"
+
 #include "ns3/traced-value.h"
 
 namespace ns3 {
 
+class TcpSocketState;
+
 class TcpLp : public TcpNewReno
 {
 public:
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-option-sack.cc ns-3.31/src/internet/model/tcp-option-sack.cc
--- ns-3.30.1/src/internet/model/tcp-option-sack.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-option-sack.cc	2020-06-27 17:38:30.000000000 -0700
@@ -108,7 +108,7 @@
 
   uint8_t size = i.ReadU8 ();
   NS_LOG_LOGIC ("Size: " << static_cast<uint32_t> (size));
-  m_sackList.empty ();
+  m_sackList.clear ();
   uint8_t sackCount = (size - 2) / 8;
   while (sackCount)
     {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-prr-recovery.cc ns-3.31/src/internet/model/tcp-prr-recovery.cc
--- ns-3.30.1/src/internet/model/tcp-prr-recovery.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-prr-recovery.cc	2020-06-27 17:38:30.000000000 -0700
@@ -22,8 +22,8 @@
  */
 
 #include "tcp-prr-recovery.h"
-#include "ns3/tcp-socket-base.h"
-#include "ns3/tcp-congestion-ops.h"
+#include "tcp-socket-state.h"
+
 #include "ns3/log.h"
 
 namespace ns3 {
@@ -58,7 +58,6 @@
     m_prrDelivered (recovery.m_prrDelivered),
     m_prrOut (recovery.m_prrOut),
     m_recoveryFlightSize (recovery.m_recoveryFlightSize),
-    m_previousSackedBytes (recovery.m_previousSackedBytes),
     m_reductionBoundMode (recovery.m_reductionBoundMode)
 {
   NS_LOG_FUNCTION (this);
@@ -71,29 +70,23 @@
 
 void
 TcpPrrRecovery::EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                            uint32_t unAckDataCount, uint32_t lastSackedBytes)
+                               uint32_t unAckDataCount, uint32_t deliveredBytes)
 {
-  NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount << lastSackedBytes);
+  NS_LOG_FUNCTION (this << tcb << dupAckCount << unAckDataCount);
   NS_UNUSED (dupAckCount);
 
   m_prrOut = 0;
   m_prrDelivered = 0;
   m_recoveryFlightSize = unAckDataCount;
-  m_previousSackedBytes = lastSackedBytes;
 
-  DoRecovery (tcb, 0, lastSackedBytes);
+  DoRecovery (tcb, deliveredBytes);
 }
 
 void
-TcpPrrRecovery::DoRecovery (Ptr<TcpSocketState> tcb, uint32_t lastAckedBytes,
-                         uint32_t lastSackedBytes)
+TcpPrrRecovery::DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes)
 {
-  NS_LOG_FUNCTION (this << tcb << lastAckedBytes << lastSackedBytes);
-  uint32_t lastDeliveredBytes;
-  int changeInSackedBytes = int (lastSackedBytes - m_previousSackedBytes);
-  lastDeliveredBytes = lastAckedBytes + changeInSackedBytes > 0 ? lastAckedBytes + changeInSackedBytes : 0;
-  m_previousSackedBytes = lastSackedBytes;
-  m_prrDelivered += lastDeliveredBytes;
+  NS_LOG_FUNCTION (this << tcb << deliveredBytes);
+  m_prrDelivered += deliveredBytes;
 
   int sendCount;
   if (tcb->m_bytesInFlight > tcb->m_ssThresh)
@@ -109,7 +102,7 @@
         }
       else if (m_reductionBoundMode == SSRB)
         {
-          limit = std::max (m_prrDelivered - m_prrOut, lastDeliveredBytes) + tcb->m_segmentSize;
+          limit = std::max (m_prrDelivered - m_prrOut, deliveredBytes) + tcb->m_segmentSize;
         }
       sendCount = std::min (limit, static_cast<int> (tcb->m_ssThresh - tcb->m_bytesInFlight));
     }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/internet/model/tcp-prr-recovery.h ns-3.31/src/internet/model/tcp-prr-recovery.h
--- ns-3.30.1/src/internet/model/tcp-prr-recovery.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/internet/model/tcp-prr-recovery.h	2020-06-27 17:38:30.000000000 -0700
@@ -20,7 +20,8 @@
  *         Mohit P. Tahiliani <tahiliani@nitk.edu.in>
  *
  */
-#pragma once
+#ifndef TCP_PRR_RECOVERY_H
+#define TCP_PRR_RECOVERY_H
 
 #include "ns3/tcp-recovery-ops.h"
 
@@ -72,10 +73,9 @@
   std::string GetName () const override;
 
   virtual void EnterRecovery (Ptr<TcpSocketState> tcb, uint32_t dupAckCount,
-                              uint32_t unAckDataCount, uint32_t lastSackedBytes) override;
+                              uint32_t unAckDataCount, uint32_t deliveredBytes) override;
 
-  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t lastAckedBytes,
-                           uint32_t lastSackedBytes) override;
+  virtual void DoRecovery (Ptr<TcpSocketState> tcb, uint32_t deliveredBytes) override;
 
   virtual void ExitRecovery (Ptr<TcpSocketState> tcb) override;
 
@@ -87,8 +87,8 @@
   uint32_t m_prrDelivered                   {0};    //!< total bytes delivered during recovery phase
   uint32_t m_prrOut                         {0};    //!< total bytes sent during recovery phase
   uint32_t m_recoveryFlightSize             {0};    //!< value of bytesInFlight at the start of recovery phase
-  uint32_t m_previousSackedBytes            {0};    //!< total bytes SACKed by the previous ACK
   ReductionBound_t m_reductionBoundMode     {SSRB}; //!< mode of Reduction Bound to be used
 };
 } // namespace ns3
 
+#endif /* TCP_PRR_RECOVERY_H */
